static char *cvs_id =" $Id: xnd_new.c,v 1.8 2006/04/13 10:14:41 berar Exp $ ";
/* XND_NEW.C       new file */

#define USE_VAR
#define USE_KEYS
#define USE_SETS
#define USE_MODUL
#define USE_SYM
#define USE_SCAN
#define USE_EXPER
#define USE_DIFDAT
#define USE_ATOM
#define USE_PENAL
#define USE_PHASE
#include "../xnd_def.h"

#include <string.h>
#include <ctype.h>

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
void write_remark( P_(sint) nombre)
#ifdef NO_PROTO
sint nombre;
#endif
{   char remark[102];
    fprintf (new_fich,"\n");
    while (nombre--) 
    if (remark_fich != NULL)
     {    fgets (remark, 100, remark_fich);
          fputs (remark, new_fich);
          }
     }
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
static void new_coord (P_(int) nb, P_(int) angle, P_(TYPE_PENAL *) dist)
#ifdef NO_PROTO
int nb, angle;
TYPE_PENAL *dist;
#endif
{ int   i,j,n;
  TYPE_PENAL  *p_dist = dist;
  TYPE_COORD *coord;
  for (i=0;i<nb;i++,p_dist++)
  {  write_remark (p_dist->remark);
     fprintf (new_fich,"%d %f",p_dist->nb_coord,p_dist->sigma);
		fnew_var(p_dist->dist,VAR_STD);
		coord = p_dist->coord;
		for (j=0;j<p_dist->nb_coord;j++,coord++)
		{   fprintf (new_fich,"%s %6s",j==0?"\n":"",
			atom_ptr(coord->at0)->nom);
		    for (n=0; n<=angle;n++)
		    {	fprintf (new_fich,"  %6s",
			    atom_ptr(coord->endat[n].at)->nom);
			fprint_xyz_pos  (new_fich, coord->endat[n].coef, '\n');
			}
		    }
		}
	}

/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
static void new_atom(P_(void))
{  char *e, buffer[10];
   write_remark (l_atom->remark);
   e = atom_dif(buffer);
	if (new_keys("ATOM", 
		    "NAME", KEYTYPE_CHAR,  STD_KEY, l_atom->nom, (char*) "",
          "CHEM", KEYTYPE_CHAR, STD_KEY, e, (char*) "",
          "CASE", KEYTYPE_INT,  STD_KEY, l_atom->nature, (int) 0,
           NULL ) == -1 )	
			  fprintf(new_fich,"\n %s %s %d",l_atom->nom, e,l_atom->nature);
	 fnew_var(l_atom->x, "COORD");
	 if ( l_atom->n_modul ) fnew_var(l_atom->modul, "MODUL");
	 if ( l_atom->n_anharm ) fnew_var(l_atom->anharm, "ANHARM");
	 }
/* -------------------------------------------------------------------- */
static void new_magnet (P_(void))
{   TYPE_MODUL * magnet;
    float zero = 0.0;
	 
    magnet = l_phase->magnet;
    write_remark (magnet->remark);
   tst_abort ((new_keys( "MAGNET", 
        "ORDER", KEYTYPE_INT,  EXT_KEY, magnet->order, (int) 1,
        "CENTER_X", KEYTYPE_FLOAT,  EXT_KEY, &(magnet->center_4d[0]), &zero,
        "CENTER_Y", KEYTYPE_FLOAT,  EXT_KEY, &(magnet->center_4d[1]), &zero,
        "CENTER_Z", KEYTYPE_FLOAT,  EXT_KEY, &(magnet->center_4d[2]), &zero,
        "SYMGRP", KEYTYPE_CHAR,  STD_KEY, magnet->symgrp, "",
			NULL) == -1), "key @MAGNET is necessary for magnetic info\n");

    /*fnew_var(modul->vector, VAR_STD);   */

    }
/* -------------------------------------------------------------------- */
static void new_modul (P_(void))
{  TYPE_MODUL * modul;
   float zero = 0.0;
   char *compo_symgrp, *compo_sym4grp;
	 
   modul = l_phase->modul;
   write_remark (modul->remark);
   compo_symgrp=compo_sym4grp=NULL;
   if (modul->compo_atom)
	{  compo_symgrp=modul->compo_sym->nom;
      if (strcmp(compo_symgrp,"SWAP_COMPO")!= 0)
	    compo_sym4grp=modul->compo_sym4->nom;
		 }
   if ( new_keys ( "MODUL", 
	   "SIZE", KEYTYPE_INT,  EXT_KEY, modul->size, (int) 1,
	   "ORDER", KEYTYPE_INT,  EXT_KEY, modul->order, (int) KEY_MODUL_ORDER,
      "CENTER_X", KEYTYPE_FLOAT,  EXT_KEY, &(modul->center_4d[0]), &zero,
      "CENTER_Y", KEYTYPE_FLOAT,  EXT_KEY, &(modul->center_4d[1]), &zero,
      "CENTER_Z", KEYTYPE_FLOAT,  EXT_KEY, &(modul->center_4d[2]), &zero,
      "SYMGRP", KEYTYPE_CHAR,  STD_KEY, modul->symgrp, "",
	   "COMPO", KEYTYPE_INT,  EXT_KEY, modul->compo_atom, (int) 0,
      "COMPO_SYM", KEYTYPE_CHAR,  STD_KEY, compo_symgrp, "",
      "COMPO_SYM4", KEYTYPE_CHAR,  STD_KEY, compo_sym4grp, "",
		NULL) == -1 )
    {  fprintf (new_fich," %d %d %d %d\n %.4f %.4f %.4f\n %s\n", 
	       modul->size, modul->order, modul->nb_sets, modul->compo_atom,
          modul->center_4d[0], modul->center_4d[1], 
			 modul->center_4d[2], modul->symgrp);
       if (compo_symgrp) fprintf (new_fich," %s\n", compo_symgrp);
       if (compo_sym4grp) fprintf (new_fich," %s\n", compo_sym4grp);
		 }
   fprintf (new_fich,"\n");
    }
/* ------------------------------------------------------------------ */
static void new_sets_hkl (P_(void))
{   int i;
    current_sets = l_phase->sets;
	 for (i=0; i==0||i<l_phase->nb_sets; i++, current_sets++)
     if (current_sets->nb_hkl > 0)
        fnew_var(current_sets->intensity, NULL );
    }
/* -------------------------------------------------------------------- */
static void new_crystal (P_(void))
{  int    i,j, m_prof;
   char  buffer[10];
   float *p_bond;

   push_err_msg("new_crystal");
	m_prof = (l_phase->sets && l_phase->m_prof) ? -l_phase->n_prof : l_phase->n_prof;
	strcpy(buffer, "P1");
   if (l_phase->nt_orien != l_phase->n_orien) l_phase->n_orien *=-1;
	if ( new_keys( "CRYSTAL", 
	    "SYMGRP",  KEYTYPE_CHAR,  STD_KEY, l_phase->symgrp->nom  , buffer,  
	    "ATOM",  KEYTYPE_INT,  STD_KEY, l_phase->n_atom  , KEY_CRYST_ATOM,  
	    "ORIEN", KEYTYPE_INT,  EXT_KEY, l_phase->n_orien , (int) 0,  
	    "PROF",  KEYTYPE_INT,  EXT_KEY, m_prof  , (int) 0,  
	    "BLOCK", KEYTYPE_INT,  EXT_KEY, l_phase->nb_bloc , (int) 0,  
	    "SETS",  KEYTYPE_INT,  EXT_KEY, l_phase->nb_sets , (int) 0,  
	    "BOND",  KEYTYPE_INT,  ALL_KEY, l_phase->nb_bond , (int) 0,  
	    "UNCOH", KEYTYPE_INT,  ALL_KEY, l_phase->uncoherent , (int) 0,  
	   NULL) == -1 )
	fprintf (new_fich,"%s\n %d  %d  %d  %d  %d  %d\n",
	  l_phase->symgrp->nom, l_phase->n_orien, m_prof, 
	  l_phase->n_atom, l_phase->nb_bloc, l_phase->nb_tds, l_phase->nb_bond);
	fnew_var(l_phase->cell, NULL);
   if (l_phase->nature==PHASE_MAGNET||l_phase->nature==PHASE_MAGMOD)
            new_magnet();
   if (l_phase->nature==PHASE_MODUL||l_phase->nature==PHASE_MAGMOD)
            new_modul();
   if (l_phase->nb_sets) sets_new(l_phase->sets, l_phase->nb_sets);
   if (l_phase->vector) fnew_var(l_phase->vector, VAR_STD);
	if (l_phase->nt_orien)
	{   write_remark (l_phase->remark_orien);
             for (j=0; j<l_phase->nt_orien; j++) 
			fprintf (new_fich," %d",l_phase->c_orien[j]);
	     fprintf (new_fich,"\n");
	     fnew_var(l_phase->orien, NULL);
	     };
	if (l_phase->n_prof)
	{  write_remark (l_phase->remark_prof);
      for (j=0; j<l_phase->n_prof; j++) 
           fprintf (new_fich," %d",l_phase->c_prof[j]);
	   fprintf (new_fich,"\n");
	   if (m_prof > 0 )  fnew_var(l_phase->prof, NULL);
	   else
		{  TYPE_SETS *l_sets;
		   for(i=0,l_sets=l_phase->sets; i<l_phase->nb_sets;i++,l_sets++)  
		      fnew_var((l_sets->prof),NULL);
			}
		fnew_var(l_phase->asym, NULL);
	   };
	fprintf (new_fich,"\n");
	for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
	   new_atom();
	if (l_phase->nb_bloc)
	{  fnew_var(l_phase->bloc, NULL);
	   for (i=0;i<l_phase->nb_bloc;i++)
	   {  fprintf (new_fich,"\n %d",l_phase->bl_atom[i]);
	      for (j=0,l_atom=l_phase->bl_ortho[i];j<l_phase->bl_atom[i];j++,l_atom++)
	        new_atom();
      }  }
    new_sets_hkl ();
    if (l_phase->uncoherent)
               fnew_var(l_phase->tds, NULL);

	if (l_phase->nb_bond)
	{   write_remark (l_phase->remark_bond);
            p_bond = l_phase->bond;
	    fprintf (new_fich,"%3d%3d\n",l_phase->nb_dist,l_phase->nb_angl);
	    for (i=0;i<l_phase->nb_bond;i++,p_bond++)
			fprintf (new_fich," %f\n",*p_bond);
		new_coord (l_phase->nb_dist, 0, l_phase->dist);
		new_coord (l_phase->nb_angl, 1, l_phase->angl);
		}
	fprintf (new_fich,"\n");
	pop_err_msg();	 
	}
/* -------------------------------------------------------------------- */
static void new_quasi_par (P_(int)is_quasi)
{  int  j;
   push_err_msg("new_quasi");
	fprintf (new_fich," %d  %d\n", l_phase->n_prof, l_phase->sets->nb_hkl);
	if (is_quasi) fnew_var(l_phase->cell, NULL);
	if (l_phase->n_prof)
	{    fprintf (new_fich,"\n");
	     for (j=0; j<l_phase->n_prof; j++) 
	         fprintf (new_fich," %d",l_phase->c_prof[j]);
	     fprintf (new_fich,"\n");
	     fnew_var(l_phase->prof, NULL);
	     fnew_var(l_phase->asym, NULL);
	     };
	fnew_var(l_phase->sets->intensity, NULL);
	pop_err_msg();	 
	}
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
static void new_radial (P_(void))
{  int j;
   push_err_msg("new_radial");
	if (new_keys("NONCRYST", 
		    "ATOM", KEYTYPE_INT,  STD_KEY, l_phase->n_atom, (int) 1,
          "DIST", KEYTYPE_INT, STD_KEY, l_phase->nb_dist, (int) 1,
          "UNCOH", KEYTYPE_INT, STD_KEY, l_phase->uncoherent, (int) 0,
           NULL ) == -1 )	
		fprintf (new_fich," %d %d %d\n", l_phase->n_atom, l_phase->nb_dist, l_phase->uncoherent);
	for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
	   new_atom();
	fnew_var(l_phase->radial, NULL);
   if (l_phase->uncoherent)  fnew_var(l_phase->tds, NULL);
	pop_err_msg();	 
	}
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
static void new_rdfpeak (P_(void))
{  int    j;
   push_err_msg("new_rdfpeak");

	new_keys("RDFPEAKS", 
	    "PEAKS",  KEYTYPE_INT,  STD_KEY,  l_phase->nb_dist ,(int)  1,  
	    "RSTEP", KEYTYPE_FLOAT, STD_KEY, &l_phase->bond[0] , &l_phase->bond[0],  
	    "RLIM",  KEYTYPE_FLOAT, STD_KEY, &l_phase->bond[1] , &l_phase->bond[1],  
	    "RMIN",  KEYTYPE_FLOAT, STD_KEY, &l_phase->bond[2] , &l_phase->bond[2],  
	    "ATOMS",  KEYTYPE_INT,  STD_KEY,  l_phase->n_atom  , (int) 1,  
   	 "PRINT", KEYTYPE_INT,   STD_KEY,  l_phase->nb_angl , (int) 0,  
	    "UNCOH", KEYTYPE_INT,   STD_KEY,  l_phase->uncoherent, (int) 1,  
	     NULL );	
	for (j=0,l_atom=l_phase->atom;j<l_phase->n_atom;j++,l_atom++)
	   new_atom();
	fnew_var(l_phase->radial, NULL);
 	pop_err_msg();	 
	}
/* -------------------------------------------------------------------- */
static void new_amorphe (P_(void))
{  push_err_msg("new_rdfpeak");
	if (new_keys("RDFPEAKS", 
		    "PEAKS", KEYTYPE_INT,   STD_KEY, l_phase->nb_dist, (int) 1,
           NULL ) == -1 )	
	fprintf (new_fich," %d\n", l_phase->nb_dist);
	fnew_var(l_phase->radial, NULL);
	pop_err_msg();	 
	}
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */
void new_cdr (P_(void))
{   int    i, j, id, nature;
	 float  def_orig, def_weight;
    char *c;
	 F_INFO *l_info;

#ifndef SEEK_SET
#define SEEK_SET 0
#endif
    push_err_msg("new_cdr (xnd_new.c)");
    new_fich = tst_open (new_name,"a", "NEW file");
    if (remark_fich != NULL) fseek (remark_fich, 0, SEEK_SET);
	for (i=0,l_exper = exper;i<n_exper;i++,l_exper++)
	{   write_remark (l_exper->remark);
       switch (l_exper->nature & ~EXPER_SINGLE_CRYSTAL )
	   {  case EXPER_RX  : nature = 0; break;
	      case EXPER_N   : nature = 1; break;
	      case EXPER_RXA : nature = 2; break;
	      case EXPER_NM  : nature = 3; break;
	      }
	    j = l_exper->n_back;
	    if ( l_exper->nature & EXPER_ENER_RESOL ) nature +=16;
	    if ( l_exper->nature & EXPER_SINGLE_CRYSTAL ) nature +=32;
	    else  if (j<=1) j = -j;
	  def_orig = KEY_EXPER_ORIG;
	  def_weight = KEY_EXPER_WEIGHT;
	  c="";
	  if (new_keys( "EXPER", 
       "TITLE",      KEYTYPE_STRING, STD_KEY,  l_exper->nom,      c,
       "NATURE",     KEYTYPE_INT, STD_KEY,    nature,           (int) KEY_EXPER_NATURE,
       "TECHN",      KEYTYPE_INT, EXT_KEY,    l_exper->techn,   (int) KEY_EXPER_TECHN,
       "FILE",       KEYTYPE_INT, STD_KEY,    l_exper->dfich,   (int) KEY_EXPER_FILE,
       "DATA",       KEYTYPE_INT, EXT_KEY,    l_exper->n_diag,  (int) KEY_EXPER_DATA,
       "LAMBDA",     KEYTYPE_INT, EXT_KEY,    l_exper->n_lambda, (int) KEY_EXPER_LAMBDA,
       "BGROUND",    KEYTYPE_INT, EXT_KEY,    l_exper->n_back,  (int) KEY_EXPER_BGROUND,
       "ALIMIT",     KEYTYPE_INT, EXT_KEY,    l_exper->as_limit,  (int) KEY_EXPER_ALIMIT,
       "ORIG",       KEYTYPE_FLOAT, EXT_KEY,  &l_exper->temp_orig, &def_orig,
       "WEIGHT",     KEYTYPE_FLOAT, EXT_KEY,  &(l_exper->weight), &def_weight, 
        NULL ) == -1 )
  fprintf(new_fich,"\n %d  %d  %d  %d  %d  %d  %.3f\n %s\n",
		nature, l_exper->techn, l_exper->n_diag,l_exper->dfich,
		l_exper->n_lambda, j,
		l_exper->temp_orig,l_exper->nom);
	    if (l_exper->dfich/10  != 2)
		{
		for (j=0,l_diag=l_exper->diag;j<l_exper->n_diag;j++,l_diag++)
		if (l_exper->dfich == 0)
		{	float step, def_step, def_start, def_stop;
		   step = (l_diag->dthetaf - l_diag->dtheta0) / (l_diag->n_points - 1);
			def_start = KEY_DATA_START;
			def_stop = KEY_DATA_STOP;
			def_step = KEY_DATA_STEP;
	      if ( new_keys("DATA", 
           "START",     KEYTYPE_FLOAT, STD_KEY,    &(l_diag->dtheta0), &def_start,
           "STOP",      KEYTYPE_FLOAT, STD_KEY,    &(l_diag->dthetaf), &def_stop, 
           "STEP",      KEYTYPE_FLOAT, STD_KEY,    &(step),            &def_step,
           "TEMP",      KEYTYPE_FLOAT, EXT_KEY,    &(l_diag->temp),    &def_orig,
           NULL ) == -1 ) fprintf (new_fich,"%f  %f  %f  %f\n",
			   l_diag->temp, l_diag->dtheta0, step, l_diag->dthetaf);
			}
		else if ( new_keys("DATA", 
           "TEMP",     KEYTYPE_FLOAT, EXT_KEY,   &(l_diag->temp),    &def_orig,
           "SIZE",     KEYTYPE_INT,   STD_KEY,   l_diag->n_points, (int) 0, 
           "FILE",     KEYTYPE_CHAR,  FEW_KEY,   l_diag->fich_name , "",
           NULL ) == -1 ) fprintf (new_fich," %.3f %d  %s\n",
			l_diag->temp, l_diag->n_points, l_diag->fich_name);
			}
		else 
		{    float def_monit = 0;
		      l_diag = l_exper->diag;
		      l_info = l_exper->f_info;
		      if ( new_keys("DATA", 
           "TEMP",     KEYTYPE_FLOAT, EXT_KEY,   &(l_diag->temp),    &def_orig,
           "SUM",     KEYTYPE_INT, EXT_KEY,      l_info->cumul,     (int)  1,
           "SKIP",    KEYTYPE_INT, EXT_KEY,      l_info->skip,      (int)  0,
           "VAR",     KEYTYPE_INT, EXT_KEY,      l_info->numvar,    (int)  1,
           "MONIT",   KEYTYPE_FLOAT, EXT_KEY,   &(l_info->mono),    &def_monit,
           "SIZE",     KEYTYPE_INT,   STD_KEY,   l_diag->n_points,  (int) 0, 
           "FILE",     KEYTYPE_CHAR,  FEW_KEY,   l_diag->fich_name , "",
           NULL ) == -1 ) fprintf (new_fich," %d %f %d %d %d %f %s\n",
     	   	        l_diag->n_points, l_info->tmin, 
     	    	        l_info->cumul, l_info->skip, l_info->numvar, 
     	    		l_info->mono, l_diag->fich_name);
			}	
		fnew_var(l_exper->onde, NULL);
		fnew_var(l_exper->back, NULL);
		fnew_var(l_exper->reglage, NULL);
		fnew_var(l_exper->instru, NULL);
		if ( asym_mode != ASYM_NO_CONVOL) fnew_var(l_exper->ascnv, NULL);
      if (l_exper->as_limit>0);
      {   write_remark(l_exper->as_remark);
          for (j=0;j<l_exper->as_limit;j++)
          {  fprintf(new_fich," %8.2f",l_exper->as_range[j]);
             }
          fprintf(new_fich,"\n");
          }
		fnew_var(l_exper->asym, NULL);
		if (l_exper->nature & EXPER_ENER_RESOL ) fnew_var(l_exper->c_exp, NULL);
		};
		
	fprintf(new_fich,"\n");
	for (i=0,l_phase = phase;i<n_phase;i++,l_phase++)
	{   write_remark (l_phase->remark);
       id = l_phase->nature;
       if (id == 1) id = l_phase->sets->nb_hkl;
       def_orig = KEY_PHASE_ORIG;
		 if (new_keys ("PHASE", 
           "TITLE",     KEYTYPE_STRING, STD_KEY,   l_phase->nom, "",
           "NATURE",    KEYTYPE_INT,   STD_KEY,    id , KEY_PHASE_NATURE, 
           "TRANSIT",   KEYTYPE_INT,   EXT_KEY, (int) l_phase->transit->dim/TRANSIT, KEY_PHASE_TRANSIT,
           "ORIG",      KEYTYPE_FLOAT, EXT_KEY,    &l_phase->temp_orig,    &def_orig,
           NULL ) == -1 ) fprintf (new_fich,"\n %d  %d %.3f\n %s\n",
		     id, l_phase->transit->dim/TRANSIT, l_phase->temp_orig,l_phase->nom);
	  	fnew_var(l_phase->ech, NULL);
	  	fnew_var(l_phase->transit, NULL);
                if (l_phase->transit->dim) fprintf(new_fich,"\n");
		switch (l_phase->nature)
		{  case PHASE_RADIAL   : new_radial (); break;
		   case PHASE_RDFPEAK  : new_rdfpeak (); break;
		   case PHASE_PARASITE : new_quasi_par (0); break;
		   case PHASE_QUASI    : new_quasi_par (1); break;
		   default             : new_crystal ();
                    };
		};
        write_remark (end0_remark);
	fprintf(new_fich,"\n %.4g  %d\n\n# %3d %f on %s",
	      marquardt,c_marquardt, prt_new, xt_eff, str_time);
        write_remark (end1_remark);
        if (ferror (new_fich) ) termine (19,"ecriture fichier new");
	new_fich = xclose (new_fich);
	pop_err_msg();
	}
/* -------------------------------------------------------------------- */
/* -------------------------------------------------------------------- */

