static char *cvs_id =" $Id: xnd_rex3.c,v 1.2 2004/07/30 08:04:37 berar Exp $ ";
/* XND_REX3.C   read the experimental data (hkl files) */

#define USE_KEYS
#define USE_SCAN
#define USE_EXPER
#define USE_OBS
#define USE_HKLOBS
#include "../xnd_def.h"
#include "xnd_rdh.h"

/* ------------------------------------------------------------------ */
static void write_hkldata (P_(TYPE_HKLOBS *) hkl_obs)
#ifdef NO_PROTO
TYPE_HKLOBS * hkl_obs;
#endif
{
   if (fwrite ((void *) hkl_obs, sizeof(TYPE_HKLOBS), 1, hkldata_fich) != 1)
       termine (15,E_WDATF);
    }
/* ------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
static int hkl_file_rd (P_(FILE *)fich, P_(int) i1, P_(int) i2)
#ifdef NO_PROTO
FILE *fich;
int i1, i2;
#endif
{   TYPE_HKLOBS hkl_obs;
    int i, total = 0;
    char d;
    
    push_err_msg("hkl_file_rd)");
    while (!feof(fich) )
    {    if (fscanf (fich, " %[#]", &d)==0)
         {   for (i=0; i<i1;i++) fscanf (fich, "%hd", &(hkl_obs.h[i])); 
             if (fscanf (fich, "%f", &(hkl_obs.f_obs))==0) break;
	     if (i2) fscanf (fich, " %f",&(hkl_obs.weight));
	       else hkl_obs.weight=1;
             hkl_obs.weight *= l_exper->weight;
	     total++;
	     write_hkldata (&hkl_obs); 
	     }
	  fscanf( fich,"%*[^\n]%*[\n]");
	  }
    pop_err_msg();
    return (total);
    }

/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void get_hkl_data (P_(void))
{    FILE   *fich;
     int    i, nb, num;
     TYPE_OBS    obs;

    push_err_msg("get_hkl_data(xnd_rex3.c)");
    if (hkldata_fich == NULL)
    {   hkldata_fich = tmpfile();
        }
    for (num=0; num < l_exper->n_diag; num++,l_diag++)
    {    l_diag->w_mini = MINFLOAT;
	if ( get_keys("DATA", NULL,
      "FILE",    KEYTYPE_CHAR, &(l_diag->fich_name), &l_diag->fich_name, 
      "SIZE",    KEYTYPE_INT,    &(nb),             0,
      "TEMP",    KEYTYPE_FLOAT,  &(l_diag->temp),    &l_exper->temp_orig,
        NULL ) == -1 )
   /* the following allows xnd_1.17 header to be read */
     fscanf (coord_fich,"%f%d %[^\n]", &l_diag->temp, &nb, l_diag->fich_name);
     fprintf (list_fich," DIAG : T = %.3f, nb=%d  : '%s'\n",
		 l_diag->temp, nb, l_diag->fich_name);
     fich = tst_open (l_diag->fich_name,"r","hkl_data file");
     switch (l_exper->dfich)
    {    case 50 : l_diag->n_points = hkl_file_rd(fich, l_exper->n_back, 0); break;
	 default : tst_abort (1,"%s","File type unknown");
	 }
     fclose (fich);
     tst_abort((l_diag->n_points==0),E_ZEROP,l_diag->fich_name);
     verbose_printf (" %d  hkl lines found in '%s'\n",l_diag->n_points,l_diag->fich_name);
	  if ( nb && nb != l_diag->n_points)
	     fprintf (list_fich,"The number of lines in the file does not agree\n");
	  }
    pop_err_msg();
    }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
