/* $Id: xnd_t_bragg.h,v 1.2 2006/04/13 10:11:59 berar Exp $ */
/* xnd_t_bragg.h    header for bragg structure   */
/* --------------------------------------------- */
#ifndef  XND_T_BRAGG_H_INCLUDED  /* included once only */
#define  XND_T_BRAGG_H_INCLUDED
/* ---------------------------------------------- */
/* sizeof(BRAGG) modified in modulated structure  */
/* ---------------------------------------------- */
typedef struct
{     float   dtheta;
      float   w_gauss;
      float   w_lorentz;
      float   asym[MAX_ASYM];
      float   i_calc;
      float   f_ab[2];
      float   f_abm[2];
      float   cor;
      float   orien;
      float   ech;
      float   dist;
      short   mu;
      short   deb;
      short   fin;
      float   s_o1;
      float   s_o2;
      float   s_c1;
      float   s_c2;
		float   s_w;
		int     s_n;
      char    phase;
      char    lambda;
      short   as_jrange;
      short   h[3];
      }   TYPE_BRAGG;
/* --------------------------------------------- */
extern TYPE_BRAGG  *act;   /* used with macro : H,K...*/
extern TYPE_BRAGG  *default_bragg;   /* allocated */
#define    H        act->h[0]
#define    K        act->h[1]
#define    L        act->h[2]
#define    DTH      act->dtheta
#define    I_C      act->i_calc
#define    F_A      act->f_ab[0]
#define    F_B      act->f_ab[1]
#define    W_G      act->w_gauss
#define    W_L      act->w_lorentz
/* --------------------------------------------- */
/* --------------------------------------------- */
#endif          /*  XND_T_BRAGG_H_INCLUDED       */
/* --------------------------------------------- */
