/* $Id: xnd_t_modul.h,v 1.1 2004/07/30 08:05:08 berar Exp $ */
/* xnd_t_modul.h    header for modulated crystal */
/* --------------------------------------------- */
#ifndef  XND_T_MODUL_H_INCLUDED  /* included once only */
#define  XND_T_MODUL_H_INCLUDED
/* ------------------------------------------------------------------ */
typedef struct
{  short  n_ind;
   short  hkl_sat[1];
   }      TYPE_SATEL;

typedef struct
{     int     size;            /* must be 1 for incom, sym ratio for magnet */
      int     order;           /* bessel, integration or superstruct ratio */
      int     nb_sets;         /* number of lines sets */
      float   center_4d[3];    /* projection of the 4D center  */
      float   t_orig;          /* for commensurate modulation */
      SYMGRP_PTR symgrp;         /* complementary ops of 4D group */
      int     compo_atom;      /* zero or first atom of the composite second cell */
      SYMGRP_PTR compo_sym;       /* internam group for the second cell   */
      SYMGRP_PTR compo_sym4;      /* modulation group for the second cell */
      int     big_cell;        /* for listing big_cell coordinates */
      sint    remark;
      }       TYPE_MODUL;
/* ------------------------------------------------------------------ */
extern TYPE_MODUL * current_modul;
extern TYPE_SATEL * current_satel;
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
/* --------------------------------------------- */
#endif          /*  XND_T_MODUL_H_INCLUDED       */
/* --------------------------------------------- */

