/* $Id: xnd_t_sets.h,v 1.1 2004/07/30 08:05:15 berar Exp $ */
/* xnd_t_sets.h    header for sets usage           */
/* --------------------------------------------- */
#ifndef  XND_T_SETS_H_INCLUDED  /* included once only */
#define  XND_T_SETS_H_INCLUDED
/* --------------------------------------------- */
#ifdef USE_SETS_RULE 
#define SETS_RULE_PTR   TYPE_SETS_RULE *
typedef enum {OPER_NONE, OPER_L_NOT, OPER_L_AND, OPER_L_OR, 
         OPER_N_EQ, OPER_N_NE, OPER_N_GT, OPER_N_GE, OPER_N_LT, OPER_N_LE,
			OPER_N_ADD, OPER_N_SUB, OPER_N_MUL, OPER_N_DIV, OPER_N_MOD, 
		   OPER_N_NEG, OPER_P_HKL, OPER_P_NUM} TYPE_SETS_OP;
typedef struct
{  TYPE_SETS_OP op;
   struct
   {  void * ptr;
      int    val;
      } left;
	void * right;
   } TYPE_SETS_RULE;
#else
#define SETS_RULE_PTR  void *
#endif
/* --------------------------------------------- */
typedef struct
{     int    nb_hkl;
		int    auto_intensity;
		char * deny_str;            
      char * allow_str;
		char * loop_str;
      sint   remark;
		SETS_RULE_PTR allow;
		SETS_RULE_PTR deny;
      VAR_PTR  prof;            /* table de 4*n_prof */
		VAR_PTR  intensity;
      }   TYPE_SETS;
/* --------------------------------------------- */
/*  xnd_sets.c                                   */
/* --------------------------------------------- */
extern TYPE_SETS * current_sets;
int sets_analyse   (TYPE_SETS *sets);
int sets_extinction(TYPE_SETS *sets);   /* allowed lines return 0, others 1 */
TYPE_SETS * sets_make(TYPE_SETS * previous, int total, int nature);
TYPE_SETS * sets_fget(TYPE_SETS * previous, int total, int* result);
void    sets_new (TYPE_SETS *sets, int number);
/* --------------------------------------------- */
#endif          /*  XND_T_SETS_H_INCLUDED        */
/* --------------------------------------------- */

 
